gtk-0.12.4: Binding to the Gtk+ graphical user interface library.

Portability | portable (depends on GHC)
Stability | provisional
Maintainer | gtk2hs-users@lists.sourceforge.net
Safe Haskell | None

Graphics.UI.Gtk.Abstract.Container

Contents

- Detail
  - Size Requisition
  - Size Allocation
  - Child attributes
- Class Hierarchy
- Types
- Methods
- Attributes
- Signals
- Deprecated

Description

Base class for widgets which contain other widgets

Synopsis

- data Container
- class WidgetClass o => ContainerClass o
- castToContainer :: GObjectClass obj => obj -> Container
- gTypeContainer :: GType
- toContainer :: ContainerClass o => o -> Container
- type ContainerForeachCB = Widget -> IO ()
- data ResizeMode
  - = ResizeParent
  - | ResizeQueue
  - | ResizeImmediate
- containerAdd :: (ContainerClass self, WidgetClass widget) => self -> widget -> IO ()
- containerRemove :: (ContainerClass self, WidgetClass widget) => self -> widget -> IO ()
- containerForeach :: ContainerClass self => self -> ContainerForeachCB -> IO ()
- containerForall :: ContainerClass self => self -> ContainerForeachCB -> IO ()
- containerGetChildren :: ContainerClass self => self -> IO [Widget]
- containerSetFocusChild :: (ContainerClass self, WidgetClass child) => self -> child -> IO ()
- containerSetFocusChain :: ContainerClass self => self -> [Widget] -> IO ()
- containerGetFocusChain :: ContainerClass self => self -> IO (Maybe [Widget])
- containerUnsetFocusChain :: ContainerClass self => self -> IO ()
- containerSetFocusVAdjustment :: ContainerClass self => self -> Adjustment -> IO ()
- containerGetFocusVAdjustment :: ContainerClass self => self -> IO (Maybe Adjustment)
- containerSetFocusHAdjustment :: ContainerClass self => self -> Adjustment -> IO ()
- containerGetFocusHAdjustment :: ContainerClass self => self -> IO (Maybe Adjustment)
- containerResizeChildren :: ContainerClass self => self -> IO ()
- containerSetBorderWidth :: ContainerClass self => self -> Int -> IO ()
- containerGetBorderWidth :: ContainerClass self => self -> IO Int
- containerGetResizeMode :: ContainerClass self => self -> IO ResizeMode
- containerSetResizeMode :: ContainerClass self => self -> ResizeMode -> IO ()
- containerResizeMode :: ContainerClass self => Attr self ResizeMode
- containerBorderWidth :: ContainerClass self => Attr self Int
- containerChild :: (ContainerClass self, WidgetClass widget) => WriteAttr self widget
- containerFocusHAdjustment :: ContainerClass self => ReadWriteAttr self (Maybe Adjustment) Adjustment
- containerFocusVAdjustment :: ContainerClass self => ReadWriteAttr self (Maybe Adjustment) Adjustment
- add :: ContainerClass self => Signal self (Widget -> IO ())
- checkResize :: ContainerClass self => Signal self (IO ())
- remove :: ContainerClass self => Signal self (Widget -> IO ())
- setFocusChild :: ContainerClass self => Signal self (Maybe Widget -> IO ())
- onAdd :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)
- afterAdd :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)
- onCheckResize :: ContainerClass self => self -> IO () -> IO (ConnectId self)
- afterCheckResize :: ContainerClass self => self -> IO () -> IO (ConnectId self)
- onRemove :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)
- afterRemove :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)
- onSetFocusChild :: ContainerClass self => self -> (Maybe Widget -> IO ()) -> IO (ConnectId self)
- afterSetFocusChild :: ContainerClass self => self -> (Maybe Widget -> IO ()) -> IO (ConnectId self)

# Detail

A Gtk+ user interface is constructed by nesting widgets inside widgets. Container widgets are the inner nodes in the resulting tree of widgets: they contain other widgets. So, for example, you might have a `Window` containing a `Frame` containing a `Label`. If you wanted an image instead of a textual label inside the frame, you might replace the `Label` widget with a `Image` widget.

There are two major kinds of container widgets in Gtk+. Both are subclasses of the abstract `Container` base class.

The first type of container widget has a single child widget and derives from `Bin`. These containers are decorators, which add some kind of functionality to the child. For example, a `Button` makes its child into a clickable button; a `Frame` draws a frame around its child and a `Window` places its child widget inside a top-level window.

The second type of container can have more than one child; its purpose is to manage layout. This means that these containers assign sizes and positions to their children. For example, a `HBox` arranges its children in a horizontal row, and a `Table` arranges the widgets it contains in a two-dimensional grid.

To fulfill its task, a layout container must negotiate the size requirements with its parent and its children. This negotiation is carried out in two phases, size requisition and size allocation.

## Size Requisition

The size requisition of a widget is it's desired width and height. This is represented by a `Requisition`.

How a widget determines its desired size depends on the widget. A `Label`, for example, requests enough space to display all its text. Container widgets generally base their size request on the requisitions of their children.

The size requisition phase of the widget layout process operates top-down. It starts at a top-level widget, typically a `Window`. The top-level widget asks its child for its size requisition by calling `widgetSizeRequest`. To determine its requisition, the child asks its own children for their requisitions and so on. Finally, the top-level widget will get a requisition back from its child.

## Size Allocation

When the top-level widget has determined how much space its child would like to have, the second phase of the size negotiation, size allocation, begins. Depending on its configuration (see `windowSetResizable`), the top-level widget may be able to expand in order to satisfy the size request or it may have to ignore the size request and keep its fixed size. It then tells its child widget how much space it gets by calling `widgetSizeAllocate`. The child widget divides the space among its children and tells each child how much space it got, and so on. Under normal circumstances, a `Window` will always give its child the amount of space the child requested.

A child's size allocation is represented by an `Allocation`. This contains not only a width and height, but also a position (i.e. X and Y coordinates), so that containers can tell their children not only how much space they have gotten, but also where they are positioned inside the space available to the container.

Widgets are required to honor the size allocation they receive; a size request is only a request, and widgets must be able to cope with any size.

## Child attributes

`Container` introduces child attributes - these are object attributes that are not specific to either the container or the contained widget, but rather to their relation. Typical examples of child attributes are the position or pack-type of a widget which is contained in a `Box`.

The `Container` class does not itself define any child attributes, they are defined (and documented) by the various `Container` subclasses.

Child attributes can be set or obtained in a similar way to ordinary attributes. So ordinary attributes are set like so:

     set object [ attr := value ]

Whereas child attributes take the child object as a parameter:

     set container [ attr child := value ]

And similarily for getting a child attribute's value:

     value <- get container (attr child)

# Class Hierarchy

     | GObject
     | +----Object
     | +----Widget
     | +----Container
     | +----Bin
     | +----Box
     | +----CList
     | +----Fixed
     | +----Paned
     | +----IconView
     | +----Layout
     | +----List
     | +----MenuShell
     | +----Notebook
     | +----Socket
     | +----Table
     | +----TextView
     | +----Toolbar
     | +----TreeView

# Types

data Container

Instances

Eq Container |
Ord Container |
GObjectClass Container |
ContainerClass Container |
WidgetClass Container |
ObjectClass Container |

class WidgetClass o => ContainerClass o

Instances

ContainerClass TreeView |
ContainerClass Toolbar |
ContainerClass TextView |
ContainerClass Table |
ContainerClass Socket |
ContainerClass Notebook |
ContainerClass MenuBar |
ContainerClass RecentChooserMenu |
ContainerClass Menu |
ContainerClass MenuShell |
ContainerClass List |
ContainerClass Layout |
ContainerClass IconView |
ContainerClass VPaned |
ContainerClass HPaned |
ContainerClass Paned |
ContainerClass Fixed |
ContainerClass CTree |
ContainerClass CList |
ContainerClass Statusbar |
ContainerClass FileChooserButton |
ContainerClass Combo |
ContainerClass InfoBar |
ContainerClass HBox |
ContainerClass FileChooserWidget |
ContainerClass FontSelection |
ContainerClass ColorSelection |
ContainerClass RecentChooserWidget |
ContainerClass VBox |
ContainerClass VButtonBox |
ContainerClass HButtonBox |
ContainerClass ButtonBox |
ContainerClass Box |
ContainerClass SeparatorToolItem |
ContainerClass RadioToolButton |
ContainerClass ToggleToolButton |
ContainerClass MenuToolButton |
ContainerClass ToolButton |
ContainerClass ToolItem |
ContainerClass ComboBoxEntry |
ContainerClass ComboBox |
ContainerClass Expander |
ContainerClass Viewport |
ContainerClass ScrolledWindow |
ContainerClass HandleBox |
ContainerClass EventBox |
ContainerClass Plug |
ContainerClass MessageDialog |
ContainerClass InputDialog |
ContainerClass FontSelectionDialog |
ContainerClass FileChooserDialog |
ContainerClass FileSelection |
ContainerClass ColorSelectionDialog |
ContainerClass AboutDialog |
ContainerClass Dialog |
ContainerClass OffscreenWindow |
ContainerClass Assistant |
ContainerClass Window |
ContainerClass ListItem |
ContainerClass SeparatorMenuItem |
ContainerClass ImageMenuItem |
ContainerClass TearoffMenuItem |
ContainerClass RadioMenuItem |
ContainerClass CheckMenuItem |
ContainerClass MenuItem |
ContainerClass Item |
ContainerClass OptionMenu |
ContainerClass FontButton |
ContainerClass ColorButton |
ContainerClass RadioButton |
ContainerClass CheckButton |
ContainerClass ToggleButton |
ContainerClass LinkButton |
ContainerClass VolumeButton |
ContainerClass ScaleButton |
ContainerClass Button |
ContainerClass AspectFrame |
ContainerClass Frame |
ContainerClass Alignment |
ContainerClass Bin |
ContainerClass ToolItemGroup |
ContainerClass ToolPalette |
ContainerClass Container |

castToContainer :: GObjectClass obj => obj -> Container

gTypeContainer :: GType

toContainer :: ContainerClass o => o -> Container

type ContainerForeachCB = Widget -> IO ()

A function that is invoked for all widgets in a container.

data ResizeMode

Resize mode, for containers

- `ResizeParent` Pass resize request to the parent
- `ResizeQueue` Queue resizes on this widget
- `ResizeImmediate` Perform the resizes now

Constructors

ResizeParent |
ResizeQueue |
ResizeImmediate |

Instances

Enum ResizeMode |
Eq ResizeMode |
Show ResizeMode |

# Methods

containerAdd

Arguments

:: (ContainerClass self, WidgetClass widget) |
=> self |
-> widget | `widget` - a widget to be placed inside `container`
-> IO () |

Adds `widget` to the container. Typically used for simple containers such as `Window`, `Frame`, or `Button`; for more complicated layout containers such as `Box` or `Table`, this function will pick default packing parameters that may not be correct. So consider functions such as `boxPackStart` and `tableAttach` as an alternative to `containerAdd` in those cases. A widget may be added to only one container at a time; you can't place the same widget inside two different containers.

containerRemove

Arguments

:: (ContainerClass self, WidgetClass widget) |
=> self |
-> widget | `widget` - a current child of `container`
-> IO () |

Removes `widget` from `container`. `widget` must be inside `container`.

containerForeach :: ContainerClass self => self -> ContainerForeachCB -> IO ()

Maps `callback` over each non-internal child of `container`. See `containerForall` for details on what constitutes an "internal" child. Most applications should use `containerForeach`, rather than `containerForall`.

containerForall

Arguments

:: ContainerClass self |
=> self |
-> ContainerForeachCB | `callback` - a callback
-> IO () |

Maps `callback` over each child of `container`, including children that are considered "internal" (implementation details of the container). "Internal" children generally weren't added by the user of the container, but were added by the container implementation itself. Most applications should use `containerForeach`, rather than `containerForall`.

containerGetChildren :: ContainerClass self => self -> IO [Widget]

Returns the container's non-internal children. See `containerForall` for details on what constitutes an "internal" child.

containerSetFocusChild

Arguments

:: (ContainerClass self, WidgetClass child) |
=> self |

-> child

    child

-> IO () |

Give the focus to a specific child of the container.

containerSetFocusChain

Arguments

:: ContainerClass self |
=> self |
-> [Widget] | `focusableWidgets` - the new focus chain.
-> IO () |

Sets a focus chain, overriding the one computed automatically by Gtk+.

In principle each widget in the chain should be a descendant of the container, but this is not enforced by this method, since it's allowed to set the focus chain before you pack the widgets, or have a widget in the chain that isn't always packed. The necessary checks are done when the focus chain is actually traversed.

containerGetFocusChain :: ContainerClass self => self -> IO (Maybe [Widget])

Retrieves the focus chain of the container, if one has been set explicitly. If no focus chain has been explicitly set, Gtk+ computes the focus chain based on the positions of the children. In that case the function returns `Nothing`.

containerUnsetFocusChain :: ContainerClass self => self -> IO ()

Removes a focus chain explicitly set with `containerSetFocusChain`.

containerSetFocusVAdjustment

Arguments

:: ContainerClass self |
=> self |
-> Adjustment | `adjustment` - an adjustment which should be adjusted when the focus is moved among the descendents of `container`
-> IO () |

Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. This function sets the vertical alignment. See `scrolledWindowGetVAdjustment` for a typical way of obtaining the adjustment and `containerSetFocusHAdjustment` for setting the horizontal adjustment.

The adjustments have to be in pixel units and in the same coordinate system as the allocation for immediate children of the container.

containerGetFocusVAdjustment

Arguments

:: ContainerClass self |
=> self |
-> IO (Maybe Adjustment) | returns the vertical focus adjustment, or `Nothing` if none has been set.

Retrieves the vertical focus adjustment for the container. See `containerSetFocusVAdjustment`.

containerSetFocusHAdjustment

Arguments

:: ContainerClass self |
=> self |
-> Adjustment | `adjustment` - an adjustment which should be adjusted when the focus is moved among the descendents of `container`
-> IO () |

Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. This function sets the horizontal alignment. See `scrolledWindowGetHAdjustment` for a typical way of obtaining the adjustment and `containerSetFocusVAdjustment` for setting the vertical adjustment.

The adjustments have to be in pixel units and in the same coordinate system as the allocation for immediate children of the container.

containerGetFocusHAdjustment

Arguments

:: ContainerClass self |
=> self |
-> IO (Maybe Adjustment) | returns the horizontal focus adjustment, or `Nothing` if none has been set.

Retrieves the horizontal focus adjustment for the container. See `containerSetFocusHAdjustment`.

containerResizeChildren :: ContainerClass self => self -> IO ()

Make the container resize its children.

containerSetBorderWidth

Arguments

:: ContainerClass self |
=> self |
-> Int | `borderWidth` - amount of blank space to leave outside the container. Valid values are in the range 0-65535 pixels.
-> IO () |

Sets the border width of the container.

The border width of a container is the amount of space to leave around the outside of the container. The only exception to this is `Window`; because toplevel windows can't leave space outside, they leave the space inside. The border is added on all sides of the container. To add space to only one side, one approach is to create a `Alignment` widget, call `widgetSetUsize` to give it a size, and place it on the side of the container as a spacer.

containerGetBorderWidth

Arguments

:: ContainerClass self |
=> self |
-> IO Int | returns the current border width

Retrieves the border width of the container. See `containerSetBorderWidth`.

containerGetResizeMode

Arguments

:: ContainerClass self |
=> self |
-> IO ResizeMode | returns the current resize mode

Returns the resize mode for the container. See `containerSetResizeMode`.

containerSetResizeMode

Arguments

:: ContainerClass self |
=> self |
-> ResizeMode | `resizeMode` - the new resize mode.
-> IO () |

Sets the resize mode for the container.

The resize mode of a container determines whether a resize request will be passed to the container's parent, queued for later execution or executed immediately.

# Attributes

containerResizeMode :: ContainerClass self => Attr self ResizeMode

Specify how resize events are handled.

Default value: `ResizeParent`

containerBorderWidth :: ContainerClass self => Attr self Int

The width of the empty border outside the containers children.

Allowed values: <= `(`maxBound` :: Int)`

Default value: 0

containerChild :: (ContainerClass self, WidgetClass widget) => WriteAttr self widget

Can be used to add a new child to the container.

containerFocusHAdjustment :: ContainerClass self => ReadWriteAttr self (Maybe Adjustment) Adjustment

'focusHadjustment' property. See `containerGetFocusHAdjustment` and `containerSetFocusHAdjustment`

containerFocusVAdjustment :: ContainerClass self => ReadWriteAttr self (Maybe Adjustment) Adjustment

'focusVadjustment' property. See `containerGetFocusVAdjustment` and `containerSetFocusVAdjustment`

# Signals

add :: ContainerClass self => Signal self (Widget -> IO ())

A widget was added to the container.

checkResize :: ContainerClass self => Signal self (IO ())

Emitted when widgets need to be queried again for their preferred size.

remove :: ContainerClass self => Signal self (Widget -> IO ())

A widget was removed from the container.

setFocusChild :: ContainerClass self => Signal self (Maybe Widget -> IO ())

A widget in the container received or lost the input focus.

# Deprecated

onAdd :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)

Deprecated: instead of 'onAdd obj' use 'on obj add'

afterAdd :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)

Deprecated: instead of 'afterAdd obj' use 'after obj add'

onCheckResize :: ContainerClass self => self -> IO () -> IO (ConnectId self)

Deprecated: instead of 'onCheckResize obj' use 'on obj checkResize'

afterCheckResize :: ContainerClass self => self -> IO () -> IO (ConnectId self)

Deprecated: instead of 'afterCheckResize obj' use 'after obj checkResize'

onRemove :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)

Deprecated: instead of 'onRemove obj' use 'on obj remove'

afterRemove :: ContainerClass self => self -> (Widget -> IO ()) -> IO (ConnectId self)

Deprecated: instead of 'afterRemove obj' use 'after obj remove'

onSetFocusChild :: ContainerClass self => self -> (Maybe Widget -> IO ()) -> IO (ConnectId self)

Deprecated: instead of 'onSetFocusChild obj' use 'on obj setFocusChild'

afterSetFocusChild :: ContainerClass self => self -> (Maybe Widget -> IO ()) -> IO (ConnectId self)

Deprecated: instead of 'afterSetFocusChild obj' use 'after obj setFocusChild'